function FuncP()
require "import"
  import "android.widget.*"
  import "com.androlua.*"
import "android.media.ToneGenerator"
import "android.media.AudioManager"
local toneGenerator = ToneGenerator(AudioManager.STREAM_ACCESSIBILITY, 100)
title={
[[require "import"
import "android.preference.PreferenceManager"
local prefs = PreferenceManager.getDefaultSharedPreferences(service)
local edit = prefs.edit()
function changeOptionValue(var_name, value)
    edit.putString(var_name, value)
    edit.apply()
end

local currentStatus = prefs.getString("", "0")

if currentStatus =="0" then
changeOptionValue("", "1")
return true

elseif currentStatus =="1" then
changeOptionValue("", "0")
return true

end
return true]],
[[[[require "import"
import "android.preference.PreferenceManager"
local prefs = PreferenceManager.getDefaultSharedPreferences(service)
local edit = prefs.edit()
function changeOptionValue(var_name, value)
    edit.putString(var_name, value)
    edit.apply()
end

changeOptionValue("", "0")
return true]],
[[require "import"
import "android.preference.PreferenceManager"
local prefs = PreferenceManager.getDefaultSharedPreferences(service)
function setServiceEnabled(serviceName, activateService)
    local edit = prefs.edit()
    edit.putBoolean(serviceName, activateService)
    edit.commit()
end
local currentStatus = prefs.getBoolean("", false)
if currentStatus then
service.(false)
    setServiceEnabled("", false)
service.playSoundClock()
else
service.(true)
setServiceEnabled("", true)
service.playSoundTick()
end]],

[[require "import"
import "android.preference.PreferenceManager"
local prefs = PreferenceManager.getDefaultSharedPreferences(service)
function setServiceEnabled(serviceName, activateService)
    local edit = prefs.edit()
    edit.putBoolean(serviceName, activateService)
    edit.commit()
end
service.(false)
    setServiceEnabled("", false)
service.(true)
setServiceEnabled("", true)]],

}
   layout={
    GridView,
    id="grid",
    numColumns=4,
}

dlg=LuaDialog(service)
.setTitle("function") --标题
dlg.View=loadlayout(layout)
grid.adapter=SingleLineAdapter(service,String(title))
dlg.show()
grid.onItemClick=function(l,v,p,i)
toneGenerator.startTone(ToneGenerator.TONE_PROP_BEEP, 200);
dlg.hide()
service.getEditText()
task(150,function()
service.paste(title[p+1])
return true
end)
end
grid.onItemLongClick=function(l,v,p,i)
toneGenerator.startTone(ToneGenerator.TONE_PROP_BEEP, 200);
dlg.hide()
task(10,function()
service.copy(title[p+1])
service.postSpeak(400,"Copied")
end)
end
dlg.show()
end





require "import"
import "android.widget.*"
import "android.content.*"
import "android.preference.PreferenceManager"
import "android.text.*"
import "java.util.Locale"
import "android.media.ToneGenerator"
import "android.media.AudioManager"

local toneGenerator = ToneGenerator(AudioManager.STREAM_ACCESSIBILITY, 100)
-- Get the shared preferences
prefs = PreferenceManager.getDefaultSharedPreferences(service)
allPreferences = prefs.getAll()

-- Convert the preferences to a Lua table
preferencesTable = {}
keys = allPreferences.keySet().toArray()
for i = 0, #keys - 1 do
    key = keys[i]
    value = allPreferences.get(key)
    preferencesTable[tostring(key)] = tostring(value)
end

-- Create a list with "key: value" format
displayList = {}
for key, value in pairs(preferencesTable) do
    table.insert(displayList, key .. ": " .. value)
end
table.sort(displayList)

-- Define the layout with EditText and ListView
local layout = {
  LinearLayout,
  orientation="vertical",
  {
    EditText,
    id="search",
    background="#ff600000",
    textSize="40sp",
    layout_width="match_parent",
    hint="Enter keyword",
    inputType="text"
  },
  {
    ListView,
    id="list",
    background="#ff000000",
    layout_width="match_parent",
    layout_height="wrap_content",
  },
}

-- Create the dialog and set the layout
local dlg = LuaDialog(service)
.setTitle("Preferences")
.setView(loadlayout(layout))

-- Set the adapter for the ListView
local adapter = ArrayAdapter(service, android.R.layout.simple_list_item_1, displayList)
list.setAdapter(adapter)

-- Function to update the list based on the search query
function updateList(query)
  local filteredList = {}
  for _, item in ipairs(displayList) do
    if item:lower():find(query:lower()) then
      table.insert(filteredList, item)
    end
  end
  adapter.clear()
  for _, item in ipairs(filteredList) do
    adapter.add(item)
  end
  adapter.notifyDataSetChanged()
end

-- Add a TextWatcher to the search EditText to filter in real-time
search.addTextChangedListener(TextWatcher{
  onTextChanged=function(s, start, before, count)
    updateList(tostring(s))
  end,
  beforeTextChanged=function(s, start, count, after) end,
  afterTextChanged=function(s) end
})

-- Function to copy text to clipboard
function copyToClipboard(text)
  local clipboard = service.getSystemService(Context.CLIPBOARD_SERVICE)
  local clip = ClipData.newPlainText("label", text)
  clipboard.setPrimaryClip(clip)
  Toast.makeText(service, "تم النسخ: " .. text, Toast.LENGTH_SHORT).show()
end

-- Set the onItemClick listener for the list to copy the key
list.onItemClick=function(l,v,p,i)
  local item = tostring(v.getText())
  local key = item:match("^(.-):")
service.copy(key)
service.speak(key..": It has been copied. ")
toneGenerator.startTone(ToneGenerator.TONE_PROP_BEEP, 200);
end

-- Set the onItemLongClick listener for the list to copy the value
list.onItemLongClickListener = AdapterView.OnItemLongClickListener{
  onItemLongClick = function(parent, view, position, id)
    local item = tostring(view.getText())
    local value = item:match(": (.+)$")
service.copy(value)
service.speak(value.. ": It has been copied. ")
toneGenerator.startTone(ToneGenerator.TONE_PROP_BEEP, 200);
    return true
  end
}


-- Show the dialog
dlg.setButton("function", function()
dlg.hide()
service.click({{"%FuncP"}})
end)
dlg.show()